jQuery.noConflict();
(function($, PLUGIN_ID) {
  "use strict";
  var config = kintone.plugin.app.getConfig(PLUGIN_ID);

  var audio_url = 'data:audio/mp3;base64,' + saito_san_dazo.audio;
  var image_url = 'data:image/jpeg;base64,' + saito_san_dazo.image;

  kintone.events.on([
    'app.record.index.show',
    'app.record.detail.show',
    'app.record.create.show',
    'app.record.edit.show',
    'mobile.app.record.index.show',
    'mobile.app.record.detail.show',
    'mobile.app.record.create.show',
    'mobile.app.record.edit.show'
  ], function(event) {
    // プラグイン有効化フラグが無効の際にはここで終了
    if (config['activation'] == 'deactive') {
      return event;
    }
    // オーディオ追加
    $(document.body).append(
      $('<audio>').prop({
        'id': "saito_san",
        'preload': "auto"
      }).append(
        $('<source>').prop({
          'src': audio_url,
          'type': "audio/mp3"
        })
      )
    );

    // ボタン追加
    if(!$('#saito_san-button')[0]){
      var el = kintone.app.getHeaderMenuSpaceElement() || kintone.app.record.getHeaderMenuSpaceElement() || kintone.mobile.app.getHeaderSpaceElement();
      $(el).append($('<button>').prop({
        'id': 'saito_san-button'
      }).addClass('kintoneplugin-button-dialog-ok').text('斎藤さんだぞ！'));      
    }

    // ボタンクリックイベント
    $('#saito_san-button').on('click', function() {
      var saito = $('#saito_san');
      saito[0].currentTime = 0;
      saito[0].play();
      if(event.type.indexOf('mobile') < 0){ // モバイルでは画像表示しない
        showImage();
      }
    });
    return event;
  });

  // 画像表示
  function showImage() {
    // 要素作成等初期化処理
    if ($('.kintone-saito_san').length == 0) {
      // 斎藤さん設置用要素と背景要素の作成
      var spin_div = $('<div id ="kintone-saito_san" class="kintone-saito_san"></div>');
      var spin_bg_div = $('<div id ="kintone-saito_san-bg" class="kintone-saito_san"></div>');

      // 斎藤さん用要素をbodyにappend
      $(document.body).append(spin_div, spin_bg_div);

      $(spin_div).append(
        $('<img>').prop({
          'src': image_url,
          'id': 'saito_san-image'
        })
      );

      $('#saito_san-image').bind("load", function() {
        var $saito_san = $('#saito_san-image');

        var image_ratio = $saito_san.height() / $saito_san.width(); // 画像の幅高比
        var win_ratio = $(window).height() / $(window).width(); // ウィンドウの幅高比
        var w;
        var h; // 幅、高さ
        var margin = 50; // 上下左右の最低マージン

        if (image_ratio > win_ratio) { // 画像の方がウィンドウより縦長
          h = $(window).height() - 2 * margin; // 画像の高さ　ウィンドウに合わせる
          if (h < $(window).height()) h = $(window).height() - 2 * margin;
          w = h / image_ratio;
        } else { //  ウィンドウの方が縦長
          w = $(window).width() - 2 * margin; // 画像幅　元の画像に合わせる
          if (w < $(window).width()) w = $(window).width() - 2 * margin;
          h = w * image_ratio;
        }

        var left = ($(window).width() - w) / 2 + $saito_san.width() / 2;
        var top = ($(window).height() - h) / 2 + $(window).scrollTop() + $saito_san.height()/2;

        // 斎藤さん動作に伴うスタイル設定
        $(spin_div).css({
          'position': 'absolute',
          'left': left + 'px',
          'top': top + 'px',
          'width': w + 'px',
          'height': h + 'px',
          'z-index': '510'
        });
        $(spin_bg_div).css({
          'position': 'absolute',
          'top': '0px',
          'z-index': '500',
          'width': '150%',
          'height': '150%',
          'background-color': '#000',
          'opacity': '0.5',
          'filter': 'alpha(opacity=50)',
          '-ms-filter': "alpha(opacity=50)"
        });
      });
    }

    // 斎藤さん始動（表示）
    $('.kintone-saito_san').show();
    setTimeout(function() {
      $('.kintone-saito_san').fadeOut();
    }, 2500);
  }
})(jQuery, kintone.$PLUGIN_ID);
